Index: modules/uoa-repository-manager-service/trunk/src/main/java/eu/dnetlib/repo/manager/service/security/AuthoritiesUpdater.java
===================================================================
--- modules/uoa-repository-manager-service/trunk/src/main/java/eu/dnetlib/repo/manager/service/security/AuthoritiesUpdater.java	(nonexistent)
+++ modules/uoa-repository-manager-service/trunk/src/main/java/eu/dnetlib/repo/manager/service/security/AuthoritiesUpdater.java	(revision 61441)
@@ -0,0 +1,98 @@
+package eu.dnetlib.repo.manager.service.security;
+
+import org.apache.log4j.Logger;
+import org.mitre.openid.connect.model.OIDCAuthenticationToken;
+import org.springframework.beans.factory.annotation.Autowired;
+import org.springframework.security.core.Authentication;
+import org.springframework.security.core.GrantedAuthority;
+import org.springframework.security.core.context.SecurityContext;
+import org.springframework.security.core.context.SecurityContextHolder;
+import org.springframework.security.oauth2.common.exceptions.UnauthorizedClientException;
+import org.springframework.security.web.context.HttpSessionSecurityContextRepository;
+import org.springframework.session.ExpiringSession;
+import org.springframework.session.FindByIndexNameSessionRepository;
+import org.springframework.stereotype.Service;
+
+import java.util.Collection;
+import java.util.HashSet;
+import java.util.Map;
+
+
+@Service
+public class AuthoritiesUpdater extends HttpSessionSecurityContextRepository {
+
+    private static final Logger logger = Logger.getLogger(AuthoritiesUpdater.class);
+
+    @Autowired
+    FindByIndexNameSessionRepository sessions;
+
+    public void update(String email, Collection<? extends GrantedAuthority> authorities) {
+        if (sessions != null) {
+            Map<String, ExpiringSession> map = sessions.
+                    findByIndexNameAndIndexValue(FindByIndexNameSessionRepository.PRINCIPAL_NAME_INDEX_NAME, email);
+            if (map != null) {
+                logger.debug(map.values().toArray().length);
+                for (ExpiringSession session : map.values()) {
+                    logger.debug(session.getId());
+                    if (!session.isExpired()) {
+                        SecurityContext securityContext = session.getAttribute(SPRING_SECURITY_CONTEXT_KEY);
+                        Authentication authentication = securityContext.getAuthentication();
+                        if (authentication instanceof OIDCAuthenticationToken) {
+                            OIDCAuthenticationToken authOIDC = (OIDCAuthenticationToken) authentication;
+                            logger.debug(authorities);
+                            securityContext.setAuthentication(new OIDCAuthenticationToken(authOIDC.getSub(), authOIDC.getIssuer(),
+                                    authOIDC.getUserInfo(), authorities, authOIDC.getIdToken(),
+                                    authOIDC.getAccessTokenValue(), authOIDC.getRefreshTokenValue()));
+                            logger.debug("Update authorities");
+                            session.setAttribute(SPRING_SECURITY_CONTEXT_KEY, securityContext);
+                            sessions.save(session);
+                        }
+                    }
+                }
+            }
+        }
+    }
+
+    public void update(String email, Update update) {
+        Collection<? extends GrantedAuthority> authorities = update.authorities(SecurityContextHolder.getContext().getAuthentication().getAuthorities());
+        this.update(email, authorities);
+    }
+
+    public void addRole(String email, GrantedAuthority role) {
+        this.update(email, old -> {
+            HashSet<GrantedAuthority> authorities = new HashSet<>(old);
+            authorities.add(role);
+            return authorities;
+        });
+    }
+
+    public void addRole(GrantedAuthority role) {
+        Authentication auth = SecurityContextHolder.getContext().getAuthentication();
+        if (auth instanceof OIDCAuthenticationToken) {
+            OIDCAuthenticationToken oidcAuth = (OIDCAuthenticationToken) auth;
+            this.addRole(oidcAuth.getUserInfo().getEmail(), role);
+        } else {
+            throw new UnauthorizedClientException("User auth is not instance of OIDCAuthenticationToken");
+        }
+    }
+
+    public void removeRole(String email, GrantedAuthority role) {
+        this.update(email, old -> {
+            HashSet<GrantedAuthority> authorities = new HashSet<>(old);
+            authorities.remove(role);
+            return authorities;
+        });
+    }
+
+    public void removeRole(GrantedAuthority role) {
+        Authentication auth = SecurityContextHolder.getContext().getAuthentication();
+        if (auth instanceof OIDCAuthenticationToken) {
+            OIDCAuthenticationToken oidcAuth = (OIDCAuthenticationToken) auth;
+            this.removeRole(oidcAuth.getUserInfo().getEmail(), role);
+        }
+    }
+
+    public interface Update {
+        Collection<? extends GrantedAuthority> authorities(Collection<? extends GrantedAuthority> old);
+    }
+}
Index: modules/uoa-repository-manager-service/trunk/src/main/java/eu/dnetlib/repo/manager/service/ValidatorServiceImpl.java
===================================================================
--- modules/uoa-repository-manager-service/trunk/src/main/java/eu/dnetlib/repo/manager/service/ValidatorServiceImpl.java	(revision 61440)
+++ modules/uoa-repository-manager-service/trunk/src/main/java/eu/dnetlib/repo/manager/service/ValidatorServiceImpl.java	(revision 61441)
@@ -127,7 +127,7 @@
     }
 
     @Override
-    @PreAuthorize("hasRole('ROLE_USER') and #jobForValidation.userEmail == authentication.userInfo.email")
+    @PreAuthorize("hasAuthority('REGISTERED_USER') and #jobForValidation.userEmail == authentication.userInfo.email")
     public JobForValidation submitJobForValidation(JobForValidation jobForValidation) throws ValidatorServiceException {
         LOGGER.debug("Submit job for validation with id : " + jobForValidation.getDatasourceId());
         try {
@@ -155,7 +155,7 @@
     }
 
     @Override
-    @PreAuthorize("hasRole('ROLE_USER') and #email == authentication.userInfo.email")
+    @PreAuthorize("hasAuthority('REGISTERED_USER') and #email == authentication.userInfo.email")
     public ResponseEntity<Object> reSubmitJobForValidation(String email,
                                                            String jobId) throws JSONException, ValidatorServiceException {
         LOGGER.debug("Resubmit validation job with id : " + jobId);
@@ -242,7 +242,7 @@
     }
 
     @Override
-    @PreAuthorize("hasRole('ROLE_USER')")
+    @PreAuthorize("hasAuthority('REGISTERED_USER')")
     public List<StoredJob> getStoredJobsNew(String user,
                                             String jobType,
                                             String offset,
Index: modules/uoa-repository-manager-service/trunk/src/main/java/eu/dnetlib/repo/manager/service/EmailUtilsImpl.java
===================================================================
--- modules/uoa-repository-manager-service/trunk/src/main/java/eu/dnetlib/repo/manager/service/EmailUtilsImpl.java	(revision 61440)
+++ modules/uoa-repository-manager-service/trunk/src/main/java/eu/dnetlib/repo/manager/service/EmailUtilsImpl.java	(revision 61441)
@@ -33,12 +33,10 @@
     private boolean override = false, logonly = false;
     private String overrideEmail = null, from = null;
 
-    @Autowired
-    private MailLibrary mailLibrary;
+    private final MailLibrary mailLibrary;
+    private final CascadingPropertyLoader pLoader;
+    private final RepositoryService repositoryService;
 
-    @Autowired
-    private CascadingPropertyLoader pLoader;
-
     @Value("${services.repo-manager.baseUrl}")
     private String baseUrl;
 
@@ -55,7 +53,12 @@
     private String valBaseUrl;
 
     @Autowired
-    private RepositoryService repositoryService;
+    EmailUtilsImpl(MailLibrary mailLibrary, CascadingPropertyLoader pLoader,
+                   RepositoryService repositoryService) {
+        this.mailLibrary = mailLibrary;
+        this.pLoader = pLoader;
+        this.repositoryService = repositoryService;
+    }
 
 
     @PostConstruct
@@ -207,11 +210,11 @@
     public void sendAdminRegistrationEmail(Repository repository, Authentication authentication) throws Exception {
         try {
             String subject = "OpenAIRE content provider registration for " +
-                    repository.getDatasourceType() + "[" + repository.getEnglishName() + "]";
+                    repository.getDatasourceType() + "[" + repository.getOfficialName() + "]";
 
             String message = "Dear administrator" + ",\n" +
                     "\n" +
-                    "We received a request to register the " + repository.getDatasourceType() + "[" + repository.getEnglishName() + "]" +
+                    "We received a request to register the " + repository.getDatasourceType() + "[" + repository.getOfficialName() + "]" +
                     " to the OpenAIRE compliant list of content providers. " +
                     "\n\n" +
                     "User Contact: " + authentication.getName() + " (" + ((OIDCAuthenticationToken) authentication).getUserInfo().getEmail() + ")" +
@@ -233,12 +236,12 @@
     public void sendUserRegistrationEmail(Repository repository, Authentication authentication) throws Exception {
         try {
             String subject = "OpenAIRE content provider registration for " +
-                    repository.getDatasourceType() + "[" + repository.getEnglishName() + "]";
+                    repository.getDatasourceType() + "[" + repository.getOfficialName() + "]";
 
 //            String message = "Dear " + ((OIDCAuthenticationToken) authentication).getUserInfo().getName() + ",\n" +
             String message = "Dear "+SecurityContextHolder.getContext().getAuthentication().getName()+",\n" +
                     "\n" +
-                    "We received a request to register the " + repository.getDatasourceType() + "[" + repository.getEnglishName() + "]" +
+                    "We received a request to register the " + repository.getDatasourceType() + "[" + repository.getOfficialName() + "]" +
                     " to the OpenAIRE compliant list of content providers. " +
                     "\n\n" +
                     "Please do not reply to this message\n" +
@@ -259,7 +262,7 @@
     public void sendAdminRegisterInterfaceEmail(Repository repository, String comment, RepositoryInterface repositoryInterface, Authentication authentication) throws Exception {
         try {
             String subject = "OpenAIRE new interface registration request started for " +
-                    repository.getDatasourceType() + "[" + repository.getEnglishName() + "]";
+                    repository.getDatasourceType() + "[" + repository.getOfficialName() + "]";
 
             String message = "Dear administrator" + ",\n" +
                     "\n" +
@@ -267,7 +270,7 @@
                     "Base URL: " + repositoryInterface.getBaseUrl() + "\n" +
                     "Set: " + repositoryInterface.getAccessSet() + "\n" +
                     "Guidelines: " + repositoryInterface.getDesiredCompatibilityLevel() + "\n\n" +
-                    "to " + repository.getDatasourceType() + "[" + repository.getEnglishName() + "].\n";
+                    "to " + repository.getDatasourceType() + "[" + repository.getOfficialName() + "].\n";
 
             if (comment != null)
                 message += "\nThe users comment was '" + comment + "'\n";
@@ -294,7 +297,7 @@
     public void sendUserRegisterInterfaceEmail(Repository repository, String comment, RepositoryInterface repositoryInterface, Authentication authentication) throws Exception {
         try {
             String subject = "OpenAIRE new interface registration request started for " +
-                    repository.getDatasourceType() + "[" + repository.getEnglishName() + "]";
+                    repository.getDatasourceType() + "[" + repository.getOfficialName() + "]";
 
             String message = "Dear "+SecurityContextHolder.getContext().getAuthentication().getName()+",\n" +
                     "\n" +
@@ -302,7 +305,7 @@
                     "Base URL: " + repositoryInterface.getBaseUrl() + "\n" +
                     "Set: " + repositoryInterface.getAccessSet() + "\n" +
                     "Guidelines: " + repositoryInterface.getDesiredCompatibilityLevel() + "\n\n" +
-                    "to " + repository.getDatasourceType() + "[" + repository.getEnglishName() + "].\n";
+                    "to " + repository.getDatasourceType() + "[" + repository.getOfficialName() + "].\n";
 
             if (comment != null) {
                 message += "\n Your comment was '" + comment + "'\n";
@@ -328,12 +331,12 @@
     public void sendUserRegistrationResultsSuccessEmail(String issuerEmail, String jobId, RepositoryInterface repositoryInterface, Repository repository, Authentication authentication) throws Exception {
         try {
             String subject = "OpenAIRE new interface registration request - results (success) for " +
-                    repository.getDatasourceType() + "[" + repository.getEnglishName() + "]";
+                    repository.getDatasourceType() + "[" + repository.getOfficialName() + "]";
 
 //            String message = "Dear " + ((OIDCAuthenticationToken) authentication).getUserInfo().getName() + ",\n" +
             String message = "Dear user,\n" +
                     "\n" +
-                    "the compatibility test on " + "[" + repository.getEnglishName() + "]" +
+                    "the compatibility test on " + "[" + repository.getOfficialName() + "]" +
                     " was successful and the datasource type \""+ repository.getDatasourceType()  + "\" will be prepared for aggregation in OpenAIRE."+
                     "\n\n" +
                     "Please note that it usually takes about 3-4 weeks until a data source is indexed and it’s metadata visible on openaire.eu.\n\n" +
@@ -361,11 +364,11 @@
     public void sendAdminRegistrationResultsSuccessEmail(String issuerEmail, String jobId,RepositoryInterface repositoryInterface, Repository repository, Authentication authentication) throws Exception {
         try {
             String subject = "OpenAIRE new interface registration request - results (success) for " +
-                    repository.getDatasourceType() + "[" + repository.getEnglishName() + "]";
+                    repository.getDatasourceType() + "[" + repository.getOfficialName() + "]";
 
             String message = "Dear admin ,\n" +
                     "\n" +
-                    "the compatibility test on " + "[" + repository.getEnglishName() + "]" +
+                    "the compatibility test on " + "[" + repository.getOfficialName() + "]" +
                     " was successful and the datasource type \""+ repository.getDatasourceType()  + "\" will be prepared for aggregation in OpenAIRE."+
                     "\n\n" +
                     "Please note that it usually takes about 3-4 weeks until a data source is indexed and it’s metadata visible on openaire.eu.\n\n" +
@@ -394,11 +397,11 @@
     public void sendUserRegistrationResultsFailureEmail(String jobId, RepositoryInterface repositoryInterface, Repository repository, Authentication authentication) throws Exception {
         try {
             String subject = "OpenAIRE new interface registration request - results (failure) for " +
-                    repository.getDatasourceType() + "[" + repository.getEnglishName() + "]";
+                    repository.getDatasourceType() + "[" + repository.getOfficialName() + "]";
             //            String message = "Dear " + ((OIDCAuthenticationToken) authentication).getUserInfo().getName() + ",\n" +
             String message = "Dear user,\n" +
                     "\n" +
-                    "the compatibility test on " + "[" + repository.getEnglishName() + "]" +
+                    "the compatibility test on " + "[" + repository.getOfficialName() + "]" +
                     " was not successful and the registration process was interrupted."+
                     "\n\n" +
                     "We will check what caused the problem and get back to you within a couple of days.\n\n" +
@@ -426,11 +429,11 @@
     public void sendAdminRegistrationResultsFailureEmail(String issuerEmail, String jobId, RepositoryInterface repositoryInterface, Repository repository, Authentication authentication) throws Exception {
         try {
             String subject = "OpenAIRE new interface registration request - results (failure) for " +
-                    repository.getDatasourceType() + "[" + repository.getEnglishName() + "]";
+                    repository.getDatasourceType() + "[" + repository.getOfficialName() + "]";
 
             String message = "Dear admin,\n" +
                     "\n" +
-                    "the compatibility test on " + "[" + repository.getEnglishName() + "]" +
+                    "the compatibility test on " + "[" + repository.getOfficialName() + "]" +
                     " was not successful and the registration process was interrupted."+
                     "\n\n" +
                     "We will check what caused the problem and get back to you within a couple of days.\n\n" +
@@ -459,12 +462,12 @@
     public void sendUserUpdateResultsSuccessEmail(String issuer, String jobId, RepositoryInterface repositoryInterface, Repository repository, Authentication authentication) throws Exception {
         try {
             String subject = "OpenAIRE interface update request - results (success) for " +
-                    repository.getDatasourceType() + "[" + repository.getEnglishName() + "]";
+                    repository.getDatasourceType() + "[" + repository.getOfficialName() + "]";
 
             //            String message = "Dear " + ((OIDCAuthenticationToken) authentication).getUserInfo().getName() + ",\n" +
             String message = "Dear user,\n" +
                     "\n" +
-                    "the compatibility test on [" + repository.getEnglishName()+"] has been successful\n\n" +
+                    "the compatibility test on [" + repository.getOfficialName()+"] has been successful\n\n" +
                     "We will check your transmitted information and adjust the aggregation settings accordingly. Please note that it usually takes about 3-4 weeks until the changes are visible on openaire.eu."+"\n\n" +
                     "Registration identifier in OpenAIRE: "+ repository.getNamespacePrefix()+
                     "\nOfficial Name:" + repository.getOfficialName() +
@@ -490,11 +493,11 @@
     public void sendAdminUpdateResultsSuccessEmail(String issuerEmail, String jobId, RepositoryInterface repositoryInterface, Repository repository, Authentication authentication) throws Exception {
             try {
                 String subject = "OpenAIRE interface update request - results (success) for " +
-                        repository.getDatasourceType() + "[" + repository.getEnglishName() + "]";
+                        repository.getDatasourceType() + "[" + repository.getOfficialName() + "]";
 
                 String message = "Dear admin,\n" +
                         "\n" +
-                        "the compatibility test on [" + repository.getEnglishName()+"] has been successful\n\n" +
+                        "the compatibility test on [" + repository.getOfficialName()+"] has been successful\n\n" +
                         "We will check your transmitted information and adjust the aggregation settings accordingly. Please note that it usually takes about 3-4 weeks until the changes are visible on openaire.eu."+"\n\n" +
                         "Registration identifier in OpenAIRE: "+ repository.getNamespacePrefix()+
                         "\nOfficial Name:" + repository.getOfficialName() +
@@ -521,12 +524,12 @@
     public void sendUserUpdateResultsFailureEmail(String issuer, String jobId, RepositoryInterface repositoryInterface, Repository repository, Authentication authentication) throws Exception {
         try {
             String subject = "OpenAIRE interface update request - results (failure) for " +
-                    repository.getDatasourceType() + "[" + repository.getEnglishName() + "]";
+                    repository.getDatasourceType() + "[" + repository.getOfficialName() + "]";
 
             //            String message = "Dear " + ((OIDCAuthenticationToken) authentication).getUserInfo().getName() + ",\n" +
             String message = "Dear user,\n" +
                     "\n" +
-                    "the compatibility test on " + "[" + repository.getEnglishName() + "]" +
+                    "the compatibility test on " + "[" + repository.getOfficialName() + "]" +
                     " was not successful."+
                     "\n\n" +
                     "WWe will check your transmitted information to see what caused the problem and get back to you within a couple of days.\n\n" +
@@ -554,11 +557,11 @@
     public void sendAdminUpdateResultsFailureEmail(String issuerEmail, String jobId, RepositoryInterface repositoryInterface, Repository repository, Authentication authentication) throws Exception {
         try {
             String subject = "OpenAIRE interface update request - results (failure) for " +
-                    repository.getDatasourceType() + "[" + repository.getEnglishName() + "]";
+                    repository.getDatasourceType() + "[" + repository.getOfficialName() + "]";
 
             String message = "Dear admin,\n" +
                     "\n" +
-                    "the compatibility test on " + "[" + repository.getEnglishName() + "]" +
+                    "the compatibility test on " + "[" + repository.getOfficialName() + "]" +
                     " was not successful."+
                     "\n\n" +
                     "WWe will check your transmitted information to see what caused the problem and get back to you within a couple of days.\n\n" +
@@ -653,11 +656,11 @@
     public void sendAdminUpdateRepositoryInfoEmail(Repository repository, Authentication authentication) throws Exception {
         try {
             String subject = "OpenAIRE content provider update information for " +
-                    repository.getDatasourceType() + "[" + repository.getEnglishName() + "]";
+                    repository.getDatasourceType() + "[" + repository.getOfficialName() + "]";
 
             String message = "Dear administrator" + ",\n" +
                     "\n" +
-                    "We received a request to update the basic information for " + repository.getDatasourceType() + "[" + repository.getEnglishName() + "].\n\n" +
+                    "We received a request to update the basic information for " + repository.getDatasourceType() + "[" + repository.getOfficialName() + "].\n\n" +
                     "Please do not reply to this message\n" +
                     "This message has been generated automatically.\n\n" +
                     "Regards,\n" +
@@ -675,12 +678,12 @@
     public void sendUserUpdateRepositoryInfoEmail(Repository repository, Authentication authentication) throws Exception {
         try {
             String subject = "OpenAIRE content provider update information for " +
-                    repository.getDatasourceType() + "[" + repository.getEnglishName() + "]";
+                    repository.getDatasourceType() + "[" + repository.getOfficialName() + "]";
 
             //            String message = "Dear " + ((OIDCAuthenticationToken) authentication).getUserInfo().getName() + ",\n" +
             String message = "Dear user,\n" +
                     "\n" +
-                    "We received a request to update the basic information for " + repository.getDatasourceType() + "[" + repository.getEnglishName() + "].\n\n" +
+                    "We received a request to update the basic information for " + repository.getDatasourceType() + "[" + repository.getOfficialName() + "].\n\n" +
                     "Please do not reply to this message\n" +
                     "This message has been generated automatically.\n\n" +
                     "If you have any questions, write to 'helpdesk@openaire.eu'. \n\n" +
@@ -699,7 +702,7 @@
     public void sendAdminUpdateInterfaceEmail(Repository repository, String comment, RepositoryInterface repositoryInterface, Authentication authentication) throws Exception {
         try {
             String subject = "OpenAIRE interface update request started for " +
-                    repository.getDatasourceType() + "[" + repository.getEnglishName() + "]";
+                    repository.getDatasourceType() + "[" + repository.getOfficialName() + "]";
 
             String message = "Dear administrator" + ",\n" +
                     "\n" +
@@ -707,7 +710,7 @@
                     "Base URL: " + repositoryInterface.getBaseUrl() + "\n" +
                     "Set: " + repositoryInterface.getAccessSet() + "\n" +
                     "Guidelines: " + repositoryInterface.getDesiredCompatibilityLevel() + "\n\n" +
-                    "for " + repository.getDatasourceType() + "[" + repository.getEnglishName() + "].\n";
+                    "for " + repository.getDatasourceType() + "[" + repository.getOfficialName() + "].\n";
 
             if (comment != null)
                 message += "\nThe users comment was '" + comment + "'\n";
@@ -732,7 +735,7 @@
     public void sendUserUpdateInterfaceEmail(Repository repository, String comment, RepositoryInterface repositoryInterface, Authentication authentication) throws Exception {
         try {
             String subject = "OpenAIRE interface update request started for " +
-                    repository.getDatasourceType() + "[" + repository.getEnglishName() + "]";
+                    repository.getDatasourceType() + "[" + repository.getOfficialName() + "]";
 
             //            String message = "Dear " + ((OIDCAuthenticationToken) authentication).getUserInfo().getName() + ",\n" +
             String message = "Dear user,\n" +
@@ -741,7 +744,7 @@
                     "Base URL: " + repositoryInterface.getBaseUrl() + "\n" +
                     "Set: " + repositoryInterface.getAccessSet() + "\n" +
                     "Guidelines: " + repositoryInterface.getDesiredCompatibilityLevel() + "\n\n" +
-                    "for " + repository.getDatasourceType() + "[" + repository.getEnglishName() + "].\n";
+                    "for " + repository.getDatasourceType() + "[" + repository.getOfficialName() + "].\n";
 
             if (comment != null) {
                 message += "\n Your comment was '" + comment + "'\n";
